"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.RouteContext = RouteContext;
exports.Routing = void 0;

function _react() {
  const data = _interopRequireWildcard(require("react"));

  _react = function () {
    return data;
  };

  return data;
}

function _reactRouterDom() {
  const data = require("react-router-dom");

  _reactRouterDom = function () {
    return data;
  };

  return data;
}

function _slotRouter() {
  const data = require("./slot-router");

  _slotRouter = function () {
    return data;
  };

  return data;
}

let Routing;
exports.Routing = Routing;

(function (Routing) {
  Routing[Routing["url"] = 0] = "url";
  Routing[Routing["hash"] = 1] = "hash";
  Routing[Routing["inMemory"] = 2] = "inMemory";
})(Routing || (exports.Routing = Routing = {}));

function RouteContext({
  rootRoutes,
  routeSlot,
  reactRouterUi,
  routing = Routing.url
}) {
  const Router = getRouter(routing);
  return /*#__PURE__*/_react().default.createElement(Router, null, /*#__PURE__*/_react().default.createElement(RouterGetter, {
    onRouter: reactRouterUi.setRouter
  }), /*#__PURE__*/_react().default.createElement(_slotRouter().SlotRouter, {
    slot: routeSlot,
    rootRoutes: rootRoutes
  }));
}

function getRouter(type) {
  switch (type) {
    case Routing.inMemory:
      return _reactRouterDom().MemoryRouter;

    case Routing.hash:
      return _reactRouterDom().HashRouter;

    case Routing.url:
    default:
      return _reactRouterDom().BrowserRouter;
  }
} // needs to be rendered inside of <BrowserRouter/>


function RouterGetter({
  onRouter: onHistory
}) {
  const history = (0, _reactRouterDom().useHistory)();
  (0, _react().useEffect)(() => onHistory(history), [history]);
  return null;
}

//# sourceMappingURL=route-context.js.map